<template>
  <section view="auth login" class="alv_container">
    <form class="login" @submit.prevent="handleSubmit">
      <header class="login__header">OIDAR</header>
      <fieldset class="email">
        <label for="email" class="email__label">
          Email
        </label>
        <input
          name="email"
          type="text"
          v-model="form.email"
          class="email__input"
          maxlength=100
          minlength=6
          placeholder="email min 6 chars"
          required>
      </fieldset>
      <fieldset class="password">
        <label for="password" class="password__label">
          Password
        </label>
        <input
          name="password"
          type="password"
          v-model="form.password"
          class="password__input"
          maxlength=100
          minlength=8
          placeholder="pwd min 8 chars"
          required>
      </fieldset>
      <div class="actions">
        <button class="actions__login">
          Login
        </button>
      </div>
    </form>
  </section>
</template>

<script>
import { ref } from 'vue';
import { useStore } from 'vuex';
import { useRouter } from 'vue-router';

export default {
  name: 'Login',
  setup() {
    const { dispatch } = useStore();
    const router = useRouter();
    const form = ref({ email: '', password: '' });

    const handleSubmit = async () => {
      const { token } = await dispatch('auth/doLogin', form.value);
      if (token) router.push({ name: 'Player' });
    };

    return {
      handleSubmit,
      form,
    };
  },
};
</script>

<style lang="scss" scoped>
.alv_container {
  width: 100%;
  height: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
}
.login {
  display: grid;
  grid-template-rows: 4rem min-content min-content min-content;
  grid-row-gap: 1.5rem;
  border: solid 1px;
  border-radius: 8px;
  padding: 1rem 2rem;
  &__header {
    font-family: 'Courier New', monospace;
    font-size: 3rem;
  }
}
.email {
  display: grid;
  border: none;
  margin: 0;
  padding: 0;
  grid-template-rows: min-content min-content;
  grid-row-gap: .5rem;
  &__label {
    font-size: 2rem;
    color: $color-font;
    font-weight: bold;
  }
  &__input {
    padding: 0.4rem;
    border-radius: 8px;
    border: solid 1px $color-border;
    font-size: 1.5rem;
    color: #1673c7;
    background-color: white;
    box-sizing: border-box;
    &:focus {
      outline: none;
      border-color: #6bace6;
    }
    &:invalid:required {
      outline: none;
      border-color: red;
    }
  }
}
.password {
  display: grid;
  margin: 0;
  padding: 0;
  grid-template-rows: min-content min-content;
  border: none;
  grid-row-gap: .5rem;
  &__label {
    font-size: 2rem;
    color: #514b42;
    font-weight: bold;
  }
  &__input {
    padding: 0.4rem;
    border-radius: 8px;
    border: solid 1px $color-border;
    font-size: 1.5rem;
    color: #1673c7;
    background-color: white;
    box-sizing: border-box;
    &:focus {
      outline: none;
      border-color: #6bace6;
    }
    &:invalid:required {
      outline: none;
      border-color: red;
    }
  }
}
.actions {
  display: flex;
  justify-content: flex-end;
  margin-top: 2rem;
  &__login {
    font-size: 2rem;
    padding: .4rem .8rem;
    border-radius: 8px;
    border: solid 1px;
    background-color: $color-bt-active;
    color: white;
    box-sizing: border-box;
  }
}
</style>
